// from the Orange Book 2nd edition ... modified by andy

varying vec3 Reflect;
varying vec3 Refract;
varying float Ratio;

varying vec3 RefractR;
varying vec3 RefractG;
varying vec3 RefractB;

varying float RatioR;
varying float RatioG;
varying float RatioB;

uniform samplerCube envMap;

uniform int which;

vec3 color;

void main (void)
{
vec3 refractColor = vec3(textureCube(envMap, Refract));

vec3 refractColorR = vec3(textureCube(envMap, RefractR));
vec3 refractColorG = vec3(textureCube(envMap, RefractG));
vec3 refractColorB = vec3(textureCube(envMap, RefractB));

vec3 reflectColor = vec3(textureCube(envMap, Reflect));

if (which == 1) // refraction with chromatic aberration
	{
	refractColor.r = refractColorR.r;
	refractColor.g = refractColorG.g;
	refractColor.b = refractColorB.b;

	color.r = mix(refractColor.r, reflectColor.r, RatioR);
	color.g = mix(refractColor.g, reflectColor.g, RatioG);
	color.b = mix(refractColor.b, reflectColor.b, RatioB);
	}
else if (which == 0) // refraction without chromatic aberration
	{
	color = mix(refractColor, reflectColor, Ratio);
	}
else // which == 2
	color = reflectColor; // just reflection, no refraction

gl_FragColor = vec4(color, 1.0);
}